/***********************************************************************
* ADSTAR Distributed Storage Manager (ADSTAR DSM)                      *
* XOpen Backup API Client Component                                    *
*                                                                      *
***********************************************************************/
 
/**************************************************************************/
/* Header File Name: custom.h                                             */
/*                                                                        */
/* Descriptive-name: Definitions for platform specific types              */
/*                                                                        */
/* Also included here are ADSM specific return codes and constants.       */
/*                                                                        */
/**************************************************************************/

/* custom.h                                                                     
 */                                                                             
                                                                                
#ifndef _BSA_CUSTOM_H_                                                          
#define _BSA_CUSTOM_H_                                                          
                                                                                
                                                                                
/* BSA_Boolean                                                                  
 */                                                                             
typedef char BSA_Boolean;                                                       
                                                                                
/* BSA_Int16                                                                    
 */                                                                             
typedef short BSA_Int16;                                                        
                                                                                
/* BSA_Int32                                                                    
 */                                                                             
typedef long BSA_Int32;                                                         
                                                                                
/* BSA_Int64                                                                    
 */                                                                             
typedef struct {    /* defined as two 32-bit integers */                        
    BSA_Int32   left;                                                           
    BSA_Int32   right;                                                          
} BSA_Int64;                                                                    
                                                                                
/* BSA_UInt16                                                                   
 */                                                                             
typedef unsigned short BSA_UInt16;                                              
                                                                                
/* BSA_UInt32                                                                   
 */                                                                             
typedef unsigned long BSA_UInt32;                                               
                                                                                
/* BSA_UInt64                                                                   
 */                                                                             
typedef struct {        /* defined as two unsigned 32-bit integers*/            
    BSA_UInt32  left;                                                           
    BSA_UInt32  right;                                                          
} BSA_UInt64;                                                                   
                                                                                
/*-------------------------------------------------------------------------+
|  ADSM specific constants and return codes                                |
+-------------------------------------------------------------------------*/
/* XBSA library version, release, level
 */
#define BSA_API_VERSION     2
#define BSA_API_RELEASE     1
#define BSA_API_LEVEL       6

/* Constants used
 */
#define ADSM_MAX_DESC               100     /* ADSM max Desc size             */
#define ADSM_MAX_OBJINFO            100     /* ADSM max object info size      */
#define ADSM_LOWEST_BOUND           0x0000  /* value for LowerBound min       */
#define ADSM_HIGHEST_BOUND          0xFFFF  /* value for UpperBound max       */
#define ADSM_ENV_STRS               2       /* number of env strings          */
#define ObjectDescriptorVersion     1       /* ver for ObjectDescriptor       */
#define UserDescriptorVersion       1       /* ver for UserDescriptor         */
#define BSAObjectType_DATABASE      4       /* ObjectType for Databases       */

/* Return Codes Used
 */
#define BSA_RC_OK                           0x00
#define BSA_RC_SUCCESS                      0x00

#define ADSM_RC_ERROR                       0x60 /* see ADSM error log        */
#define ADSM_RC_INVALID_NODE                0x61 /* BSAObjOwner not match Init*/
#define ADSM_RC_INVALID_COPYTYPE            0x62 /* invalid copyType          */
#define ADSM_RC_INVALID_OBJTYPE             0x63 /* invalid objectType        */
#define ADSM_RC_INVALID_STATUS              0x64 /* invalid object status     */
#define ADSM_RC_INVALID_ST_VER              0x65 /* invalid structure version */
#define ADSM_RC_OWNER_TOO_LONG              0x66 /* owner too long            */
#define ADSM_RC_PSWD_TOO_LONG               0x67 /* pswd  too long            */
#define ADSM_RC_PSWD_GEN                    0x68 /* pswd access = generate    */

#endif                                                                          
                                                                                
