/***********************************************************************
* Name:
*        dapidata.h
*
* Function:
*        Dialog definitions for the sample ADSM api code
*
* Environment:
*        This is a PLATFORM-INDEPENDENT source file. As such it may
*        contain no dependencies on any specific operating system
*        environment or hardware platform.
*
***********************************************************************/
extern int16 smpapi_exit();
extern int16 smpapi_signon();
extern int16 smpapi_backup();
extern int16 smpapi_restore();
extern int16 smpapi_archive();
extern int16 smpapi_retrieve();
extern int16 smpapi_chgpw();
extern int16 smpapi_query_exit();
extern int16 smpapi_qry_backup();
extern int16 smpapi_qry_archive();
extern int16 smpapi_qry_mc();
extern int16 smpapi_qry_fs();
extern int16 smpapi_qry_sess();
extern int16 smpapi_qry_version();
extern int16 smpapi_delete_exit();
extern int16 smpapi_del_backup();
extern int16 smpapi_del_archive();
extern int16 smpapi_del_fs();
extern int16 smpapi_pref_query();
extern int16 smpapi_pref_sendbuff();
extern int16 smpapi_pref_recvbuff();
extern int16 smpapi_pref_verbose();
extern int16 smpapi_pref_restitem();
extern int16 smpapi_pref_details();
extern int16 smpapi_pref_sizeest();
extern int16 smpapi_pref_echoin();
extern int16 smpapi_pref_exit();


/*-----------------------------------------------------------------------.
| Q u e r y _ F i l e s p a c e _ D i a l o g
|========================================================================
| Dialog definition for query filespace.
|________________________________________________________________________*/
dialog query_fs_dialog[]=
  {
  {DSMAPI_FILESPACE  ,"Filespace pattern to query:",NULL},
  {DSMAPI_END,NULL,NULL}
  };


/*-----------------------------------------------------------------------.
| Q u e r y _ M g m t C l a s s _ D i a l o g
|========================================================================
| Dialog definition for query mgmt class.
|________________________________________________________________________*/
dialog query_mc_dialog[]=
  {
  {DSMAPI_MC         ,"Mgmt. class pattern to query:",NULL},
  {DSMAPI_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| S i g n o n _ D i a l o g
|========================================================================
| Dialog definition for signon pannel.
|________________________________________________________________________*/
dialog signon_dialog[]=
  {
  {DSMAPI_NODENAME   ,"      Node name:",NULL},
  {DSMAPI_OWNER      ,"     Owner name:",NULL},
  {DSMAPI_PASSWORD   ,"       Password:",NULL},
  {DSMAPI_CONFIG     ,"API Config file:",NULL},
  {DSMAPI_OPTIONS    ,"Session options:",NULL},
  {DSMAPI_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| B a c k u p _ D i a l o g
|========================================================================
| Dialog definition for creating backup objects.
|________________________________________________________________________*/
dialog backup_dialog[]=
  {
  {DSMAPI_FILESPACE  ,"                      Filespace:",NULL},
  {DSMAPI_HIGHLEVEL  ,"                      Highlevel:",NULL},
  {DSMAPI_LOWLEVEL   ,"                       Lowlevel:",NULL},
  {DSMAPI_OBJTYPE    ,"               Object Type(D/F):",NULL},
  {DSMAPI_OBJOWNER   ,"              Object Owner Name:",NULL},
  {DSMAPI_OBJCOMP    ,"Object already compressed?(Y/N):",NULL},
  {DSMAPI_MNTWAIT    ,"           Wait for mount?(Y/N):",NULL},
  {DSMAPI_FILESIZE   ,"                      File size:",NULL},
  {DSMAPI_NUM_FILES  ,"                Number of files:",NULL},
  {DSMAPI_SEED_STRING,"                    Seed string:",NULL},
  {DSMAPI_MC         ,"            Mgmt class override:",NULL},
  {DSMAPI_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| A r c h i v e _ D i a l o g
|========================================================================
| Dialog definition for creating archive objects.
|________________________________________________________________________*/
dialog archive_dialog[]=
  {
  {DSMAPI_FILESPACE  ,"                      Filespace:",NULL},
  {DSMAPI_HIGHLEVEL  ,"                      Highlevel:",NULL},
  {DSMAPI_LOWLEVEL   ,"                       Lowlevel:",NULL},
  {DSMAPI_OBJOWNER   ,"              Object Owner Name:",NULL},
  {DSMAPI_OBJCOMP    ,"Object already compressed?(Y/N):",NULL},
  {DSMAPI_MNTWAIT    ,"           Wait for mount?(Y/N):",NULL},
  {DSMAPI_FILESIZE   ,"                      File size:",NULL},
  {DSMAPI_NUM_FILES  ,"                Number of files:",NULL},
  {DSMAPI_SEED_STRING,"                    Seed string:",NULL},
  {DSMAPI_DESCRIPTION,"            Archive description:",NULL},
  {DSMAPI_MC         ,"            Mgmt class override:",NULL},
  {DSMAPI_END,NULL,NULL}
  };
/*-----------------------------------------------------------------------.
| Q u e r y _ A r c h i v e _ D i a l o g
|========================================================================
| Dialog definition for querying archive objects.
|________________________________________________________________________*/
dialog query_archive_dialog[]=
  {
  {DSMAPI_FILESPACE  ,"                        Filespace:",NULL},
  {DSMAPI_HIGHLEVEL  ,"                        Highlevel:",NULL},
  {DSMAPI_LOWLEVEL   ,"                         Lowlevel:",NULL},
  {DSMAPI_OBJOWNER   ,"                Object Owner Name:",NULL},
#if 0
  {DSMAPI_LOINSDATE  ,"           From insert date:",NULL},
  {DSMAPI_HIINSDATE  ,"             To insert date:",NULL},
  {DSMAPI_LOEXPDATE  ,"           From expire date:",NULL},
  {DSMAPI_HIEXPDATE  ,"             To expire date:",NULL},
#endif
  {DSMAPI_DESCRIPTION,"              Archive description:",NULL},
  {DSMAPI_DETAILS    ,"      Show detailed output? (Y/N):",NULL},
  {DSMAPI_MNTWAIT    ,"On Retrieve, Wait for mount?(Y/N):",NULL},
  {DSMAPI_END,NULL,NULL}
  };
/*-----------------------------------------------------------------------.
| Q u e r y _ B a c k u p _ D i a l o g
|========================================================================
| Dialog definition for querying backup objects.
|________________________________________________________________________*/
dialog query_backup_dialog[]=
  {
  {DSMAPI_FILESPACE  ,"                       Filespace:",NULL},
  {DSMAPI_HIGHLEVEL  ,"                       Highlevel:",NULL},
  {DSMAPI_LOWLEVEL   ,"                        Lowlevel:",NULL},
  {DSMAPI_OBJTYPE    ,"  Obj Type:File(F),Dir(D),Any(A):",NULL},
  {DSMAPI_ACTIVETYPE ,"   Active(A),Inactive(I),Both(B):",NULL},
  {DSMAPI_FASTACTIVE ,"If root, query all owners? (Y/N):",NULL},
  {DSMAPI_OBJOWNER   ,"               Object Owner Name:",NULL},
  {DSMAPI_DETAILS    ,"     Show detailed output? (Y/N):",NULL},
  {DSMAPI_MNTWAIT    ,"On Restore, Wait for mount?(Y/N):",NULL},
  {DSMAPI_END,NULL,NULL}
  };
/*----------------------------------------------------------------------*/
/* Q u e r y   M e n u                                                  */
/*======================================================================*/
/* Definition for the sample API query menu.                            */
/*----------------------------------------------------------------------*/

menu_entry query_entries[]=
  {
  {1,"Backup Query"       ,smpapi_qry_backup ,NULL,FALSE,query_backup_dialog},
  {2,"Archive Query"      ,smpapi_qry_archive,NULL,FALSE,query_archive_dialog},
  {3,"Management Class Query",smpapi_qry_mc  ,NULL,FALSE,query_mc_dialog},
  {4,"Filespace Query"    ,smpapi_qry_fs     ,NULL,FALSE,query_fs_dialog},
  {5,"Session Info Query" ,smpapi_qry_sess   ,NULL,FALSE,NULL},
  {6,"API Version Query"  ,smpapi_qry_version,NULL,FALSE,NULL},
  {9,"Quit"               ,smpapi_query_exit ,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu query_menu[] =
  {
  query_entries,              /* Menu entries contained in main_entries  */
  "\nChoose one of the following items to query:\n"
  };


/*----------------------------------------------------------------------*/
/* D e l e t e   M e n u                                                */
/*======================================================================*/
/* Definition for the sample API delete menu.                           */
/*----------------------------------------------------------------------*/

menu_entry delete_entries[]=
  {
  {1,"Backup Delete"   ,smpapi_del_backup ,NULL,FALSE,query_backup_dialog},
  {2,"Archive Delete"  ,smpapi_del_archive,NULL,FALSE,query_archive_dialog},
  {3,"Filespace Delete",smpapi_del_fs     ,NULL,FALSE,query_fs_dialog},
  {9,"Quit"            ,smpapi_delete_exit,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu delete_menu[] =
  {
  delete_entries,             /* Menu entries for this menu item.        */
  "\nChoose one of the following areas to delete objects from:\n"
  };

/*----------------------------------------------------------------------*/
/* P r e f   M e n u                                                    */
/*======================================================================*/
/* Definition for the system preferences menu.                          */
/*----------------------------------------------------------------------*/

menu_entry pref_entries[]=
  {
  {1,"Query Preferences"       ,smpapi_pref_query   ,NULL,FALSE,NULL},
  {2,"Set send buffer size:"   ,smpapi_pref_sendbuff,NULL,FALSE,NULL},
  {3,"Set receive buffer size:",smpapi_pref_recvbuff,NULL,FALSE,NULL},
  {4,"Use verbose output?"     ,smpapi_pref_verbose ,NULL,FALSE,NULL},
  {5,"Max restore items:"      ,smpapi_pref_restitem,NULL,FALSE,NULL},
  {6,"Show details on queries?",smpapi_pref_details ,NULL,FALSE,NULL},
  {7,"Use size est. on sends?" ,smpapi_pref_sizeest ,NULL,FALSE,NULL},
  {8,"Echo input?"             ,smpapi_pref_echoin  ,NULL,FALSE,NULL},
  {9,"Quit"                    ,smpapi_pref_exit,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu pref_menu[] =
  {
  pref_entries,               /* Menu entries for this menu item.        */
  "\nChoose one of the following preference items to change:\n"
  };

/*----------------------------------------------------------------------*/
/* M a i n   M e n u                                                    */
/*======================================================================*/
/* Definition for the sample API main menu.  The sample API is a simple */
/* table driven application that exercises the various functions of the */
/* DSM API.  This table defines the main functions that the sample      */
/* application will perform under user control.                         */
/*----------------------------------------------------------------------*/
menu_entry main_entries[]=
  {
  {0,"Signon"          ,smpapi_signon  ,NULL      ,FALSE,signon_dialog},
  {1,"Backup"          ,smpapi_backup  ,NULL      ,FALSE,backup_dialog},
  {2,"Restore"         ,smpapi_restore ,NULL      ,FALSE,query_backup_dialog},
  {3,"Archive"         ,smpapi_archive ,NULL      ,FALSE,archive_dialog},
  {4,"Retrieve"        ,smpapi_retrieve,NULL      ,FALSE,query_archive_dialog},
  {5,"Queries"         ,NULL           ,query_menu,FALSE,NULL},
  {6,"Change Password" ,smpapi_chgpw   ,NULL      ,FALSE,NULL},
  {7,"Delete object(s)",NULL           ,delete_menu,FALSE,NULL},
  {8,"Set preferences" ,NULL           ,pref_menu ,FALSE,NULL},
  {9,"Exit to system"  ,smpapi_exit    ,NULL      ,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu main_menu[]=
  {
  main_entries,               /* Menu entries contained in main_entries  */
  "\nChoose one of the following actions to test:\n"
  };


/* ******* G l o b a l s  ********  */

dsmApiVersion    apiApplVer;   /* dsmapitd.h version when appl compiled */
dsmApiVersion    apiLibVer;    /* version of API Library at run time */
uint32           dsmHandle;
ApiSessInfo      dsmSessInfo;
preferences      pref;
char             api_eyecatcher[] = "ADSM API Verify Data";

