/**************************************************************************/
/* Header File Name: dapint64.h                                           */
/*                                                                        */
/* Descriptive-name: Definitions for ADSTAR DSM external int64 routines   */
/**************************************************************************/
#define EQUAL         0
#define GREATERTHAN   1
#define LESSTHAN     -1

#define Cmp64(x,y) \
  ((x).hi > (y).hi ? GREATERTHAN : \
       ((x).hi < (y).hi ? LESSTHAN : \
               ((x).lo > (y).lo ? GREATERTHAN : \
                          ((x).lo < (y).lo ? LESSTHAN : EQUAL))))

#ifdef _NO_PROTO_
extern int64 Make64();
extern int64 Incr64();
extern int64 Decr64();
extern int64 Add64();
extern int64 Sub64();
extern void  ShiftR64();
extern void  ShiftL64();
extern int64 Mul64();
extern int64 Div64();
extern char  *I64toCh();
extern int64 ChtoI64();
#else
extern int64 Make64( uint32 n );
extern int64 Incr64( int64 x, uint32 n );
extern int64 Decr64( int64 x, uint32 n );
extern int64 Add64( int64 x, int64 y );
extern int64 Sub64( int64 x, int64 y );
extern void  ShiftR64( int64 *x, unsigned int b );
extern void  ShiftL64( int64 *x, unsigned int b );
extern int64 Mul64( int64 x, int64 y, int *overflow );
extern int64 Div64( int64 x, int64 y, int64 *rmdrP );
extern char  *I64toCh( int64 value, char *string, int radix );
extern int64 ChtoI64( char *str, int radix );
#endif
