/***********************************************************************
* ADSTAR Distributed Storage Manager (ADSTAR DSM)                      *
* API Client Component                                                 *
*                                                                      *
* (C) Copyright IBM Corporation 1993,1995                              *
***********************************************************************/

/**************************************************************************/
/* Header File Name: dsmapifp.h                                           */
/*                                                                        */
/* Descriptive-name: ADSTAR DSM API function prototypes                   */ 
/**************************************************************************/
#ifndef _H_DSMAPIFP
#define _H_DSMAPIFP
/*========================================================================*/
/*               P U B L I C   F U N C T I O N S                          */
/*========================================================================*/
 
#ifdef _NO_PROTO_
 
extern int16      dsmBeginGetData();
extern int16      dsmBeginQuery();
extern int16      dsmBeginTxn();
extern int16      dsmBindMC();
extern int16      dsmChangePW();
extern int16      dsmDeleteObj();
extern int16      dsmDeleteFS();
extern int16      dsmEndGetData();
extern int16      dsmEndGetObj();
extern int16      dsmEndQuery();
extern int16      dsmEndSendObj();
extern int16      dsmEndTxn();
extern int16      dsmGetData();
extern int16      dsmGetNextQObj();
extern int16      dsmGetObj();
extern int16      dsmInit();
extern void       dsmQueryApiVersion();
extern int16      dsmQuerySessInfo();
extern int16      dsmRCMsg();
extern int16      dsmRegisterFS();
extern int16      dsmSendData();
extern int16      dsmSendObj();
extern int16      dsmTerminate();
extern int16      dsmUpdateFS();
 
#else  /* use ANSI C required prototypes */
 
extern int16      dsmBeginGetData(
       uint32                dsmHandle,
       bool_t                mountWait,
       dsmGetType            getType,
       dsmGetList            *dsmGetObjListP
);
extern int16      dsmBeginQuery(
       uint32                dsmHandle,
       dsmQueryType          queryType,
       dsmQueryBuff          *queryBuffer
);
extern int16      dsmBeginTxn(
       uint32                dsmHandle
);
extern int16      dsmBindMC(
       uint32                dsmHandle,
       dsmObjName            *objNameP,
       dsmSendType           sendType,
       mcBindKey             *mcBindKeyP
);
extern int16      dsmChangePW(
       uint32                dsmHandle,
       char                  *oldPW,
       char                  *newPW
);
extern int16      dsmDeleteObj(
       uint32                dsmHandle,
       dsmDelType            delType,
       dsmDelInfo            delInfo
);
extern int16      dsmDeleteFS(
       uint32                dsmHandle,
       char                  *fsName,
       unsigned char         repository
);
extern int16      dsmEndGetData(
       uint32                dsmHandle
);
extern int16      dsmEndGetObj(
       uint32                dsmHandle
);
extern int16      dsmEndQuery(
       uint32                dsmHandle
);
extern int16      dsmEndSendObj(
       uint32                dsmHandle
);
extern int16      dsmEndTxn(
       uint32                dsmHandle,
       uint8                 vote,
       uint16                *reason
);
extern int16      dsmGetData(
       uint32                dsmHandle,
       DataBlk               *dataBlkPtr
);
extern int16      dsmGetNextQObj(
       uint32                dsmHandle,
       DataBlk               *dataBlkPtr
) ;
extern int16      dsmGetObj(
       uint32                dsmHandle,
       ObjID                 *objIdP,
       DataBlk               *dataBlkPtr
);
extern int16      dsmInit(
       uint32                *dsmHandle,
       dsmApiVersion         *dsmApiVersionP,
       char                  *clientNodeNameP,
       char                  *clientOwnerNameP,
       char                  *clientPasswordP,
       char                  *applicationType,
       char                  *configfile,
       char                  *options
);
extern void        dsmQueryApiVersion(
       dsmApiVersion         *apiVersionP
);
extern int16       dsmQuerySessInfo(
       uint32                dsmHandle,
       ApiSessInfo           *SessInfoP
);
extern int16       dsmRCMsg(
       uint32                dsmHandle,
       int16                 dsmRC,
       char                  *msg
);
extern int16       dsmRegisterFS(
       uint32                dsmHandle,
       regFSData             *regFilespaceP
);
extern int16       dsmSendData(
       uint32                dsmHandle,
       DataBlk               *dataBlkPtr
) ;
extern int16       dsmSendObj(
       uint32                dsmHandle,
       dsmSendType           sendType,
       void                  *sendBuff,
       dsmObjName            *objNameP,
       ObjAttr               *objAttrPtr,
       DataBlk               *dataBlkPtr
);
extern int16       dsmTerminate(
       uint32                dsmHandle
);
extern int16       dsmUpdateFS(
       uint32                dsmHandle,
       char                  *fs,
       dsmFSUpd              *fsUpdP,
       uint32                fsUpdAct
);
 
#endif /* NO _PROTOTYPE_  */
 
#endif /* _H_DSMAPIFP */
