/***********************************************************************
* Name:
*        xapidata.h
*
* Function:
*        Dialog definitions for the sample XOpen api code
*
* Environment:
*        This is a PLATFORM-INDEPENDENT source file. As such it may
*        contain no dependencies on any specific operating system
*        environment or hardware platform.
*
***********************************************************************/
#ifndef _H_XAPIDATA
#define _H_XAPIDATA

#include <ctype.h>

extern BSA_Int16 smpxapi_exit();
extern BSA_Int16 smpxapi_signon();
extern BSA_Int16 smpxapi_backup();
extern BSA_Int16 smpxapi_archive();
extern BSA_Int16 smpxapi_restore();
extern BSA_Int16 smpxapi_retrieve();
extern BSA_Int16 smpxapi_chgpw();
extern BSA_Int16 smpxapi_qry_backup();
extern BSA_Int16 smpxapi_qry_archive();
extern BSA_Int16 smpxapi_qry_sess();
extern BSA_Int16 smpxapi_qry_version();
extern BSA_Int16 smpxapi_query_exit();
extern BSA_Int16 smpxapi_pref_query();
extern BSA_Int16 smpxapi_pref_sendbuff();
extern BSA_Int16 smpxapi_pref_recvbuff();
extern BSA_Int16 smpxapi_pref_verbose();
extern BSA_Int16 smpxapi_pref_details();
extern BSA_Int16 smpxapi_pref_exit();
extern BSA_Int16 smpxapi_mar_backup();
extern BSA_Int16 smpxapi_del_archive();
extern BSA_Int16 smpxapi_del_exit();

/*-----------------------------------------------------------------------.
| S i g n o n _ D i a l o g
|========================================================================
| Dialog definition for signon pannel.
|________________________________________________________________________*/
dialog signon_dialog[]=
  {
   /* BSA_UInt16 item_type, char *item_desc,   char *item_buff */
  {BSA_API_NODENAME       ,"     BSA Object Owner name:", NULL},
  {BSA_API_OWNER          ,"BSA Application Owner name:", NULL},
  {BSA_API_PASSWORD       ,"            Security Token:", NULL},
  {BSA_API_END            ,NULL              , NULL}
  };

/*-----------------------------------------------------------------------.
| B a c k u p _ D i a l o g
|========================================================================
| Dialog definition for creating backup objects.
|________________________________________________________________________*/
dialog backup_dialog[]=
  {
  {BSA_API_OBJSPACE    ,"                       Object Space Name:",NULL},
  {BSA_API_PATH        ,"                               Path Name:",NULL},
  {BSA_API_OBJTYPE     ,"Object Type(Any/File/Directory/dataBase):",NULL},
  {BSA_API_RESTYPE     ,"                           Resource Type:",NULL},
  {BSA_API_BSAOBJOWN   ,"                   BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN   ,"           Application Object Owner Name:",NULL},
  {BSA_API_FILESIZE    ,"                             object size:",NULL},
  {BSA_API_NUM_FILES   ,"                       Number of objects:",NULL},
  {BSA_API_SEED_STRING ,"                             Seed string:",NULL},
  {BSA_API_DESCRIPTION ,"                       Descriptive Label:",NULL},
  {BSA_API_OBJINFO     ,"                      Object Information:",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| A r c h i v e _ D i a l o g
|========================================================================
| Dialog definition for creating archive objects.
|________________________________________________________________________*/
dialog archive_dialog[]=
  {
  {BSA_API_OBJSPACE    ,"             Object Space Name:",NULL},
  {BSA_API_PATH        ,"                     Path Name:",NULL},
  {BSA_API_RESTYPE     ,"                 Resource Type:",NULL},
  {BSA_API_BSAOBJOWN   ,"         BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN   ," Application Object Owner Name:",NULL},
  {BSA_API_FILESIZE    ,"                   object size:",NULL},
  {BSA_API_NUM_FILES   ,"             Number of objects:",NULL},
  {BSA_API_SEED_STRING ,"                   Seed string:",NULL},
  {BSA_API_DESCRIPTION ,"             Descriptive Label:",NULL},
  {BSA_API_OBJINFO     ,"            Object Information:",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| R e s t o r e _ D i a l o g
|========================================================================
| Dialog definition for restoring backup objects.
|________________________________________________________________________*/
dialog restore_dialog[]=
  {
  {BSA_API_OBJSPACE,
   "                                  Object Space Name:",NULL},
  {BSA_API_PATH,
   "                                          Path Name:",NULL},
  {BSA_API_OBJTYPE,
   "           Object Type(Any/File/Directory/dataBase):",NULL},
  {BSA_API_RESTYPE,
   "                                      Resource Type:",NULL},
  {BSA_API_LOWCREATE,
   "    Lower bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPCREATE,
   "    Upper bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_LOWEXPI,
   "Lower bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPEXPI,
   "Upper bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_BSAOBJOWN,
   "                              BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN,
   "                      Application Object Owner Name:",NULL},
  {BSA_API_STATUS,
   "                     Active(A), Inactive(I), aNy(N):",NULL},
  {BSA_API_LIFECYCLE,
   "                    Associated Lifecycle Group name:",NULL},
  {BSA_API_COPYGROUP,
   "              Copy Group within the lifecycle group:",NULL},
  {BSA_API_DESCRIPTION,
   "                Descriptive label ('*' is wildcard):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| R e t r i e v e _ D i a l o g
|========================================================================
| Dialog definition for retrieving archive objects.
|________________________________________________________________________*/
dialog retrieve_dialog[]=
  {
  {BSA_API_OBJSPACE,
   "                                  Object Space Name:",NULL},
  {BSA_API_PATH,
   "                                          Path Name:",NULL},
  {BSA_API_RESTYPE,
   "                                      Resource Type:",NULL},
  {BSA_API_LOWCREATE,
   "    Lower bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPCREATE,
   "    Upper bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_LOWEXPI,
   "Lower bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPEXPI,
   "Upper bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_BSAOBJOWN,
   "                              BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN,
   "                      Application Object Owner Name:",NULL},
  {BSA_API_STATUS,
   "                     Active(A), Inactive(I), aNy(N):",NULL},
  {BSA_API_LIFECYCLE,
   "                    Associated Lifecycle Group name:",NULL},
  {BSA_API_COPYGROUP,
   "              Copy Group within the lifecycle group:",NULL},
  {BSA_API_DESCRIPTION,
   "                Descriptive label ('*' is wildcard):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| Q u e r y B a c k u p _ D i a l o g
|========================================================================
| Dialog definition for querying backup objects.
|________________________________________________________________________*/
dialog query_backup_dialog[]=
  {
  {BSA_API_OBJSPACE,
   "                                  Object Space Name:",NULL},
  {BSA_API_PATH,
   "                                          Path Name:",NULL},
  {BSA_API_OBJTYPE,
   "           Object Type(Any/File/Directory/dataBase):",NULL},
  {BSA_API_RESTYPE,
   "                                      Resource Type:",NULL},
  {BSA_API_LOWCREATE,
   "    Lower bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPCREATE,
   "    Upper bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_LOWEXPI,
   "Lower bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPEXPI,
   "Upper bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_BSAOBJOWN,
   "                              BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN,
   "                      Application Object Owner Name:",NULL},
  {BSA_API_STATUS,
   "                     Active(A), Inactive(I), aNy(N):",NULL},
  {BSA_API_LIFECYCLE,
   "                    Associated Lifecycle Group name:",NULL},
  {BSA_API_COPYGROUP,
   "              Copy Group within the lifecycle group:",NULL},
  {BSA_API_DESCRIPTION,
   "                Descriptive label ('*' is wildcard):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| Q u e r y A r c h i v e _ D i a l o g
|========================================================================
| Dialog definition for querying archive objects.
|________________________________________________________________________*/
dialog query_archive_dialog[]=
  {
  {BSA_API_OBJSPACE,
   "                                  Object Space Name:",NULL},
  {BSA_API_PATH,
   "                                          Path Name:",NULL},
  {BSA_API_RESTYPE,
   "                                      Resource Type:",NULL},
  {BSA_API_LOWCREATE,
   "    Lower bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPCREATE,
   "    Upper bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_LOWEXPI,
   "Lower bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPEXPI,
   "Upper bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_BSAOBJOWN,
   "                              BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN,
   "                      Application Object Owner Name:",NULL},
  {BSA_API_STATUS,
   "                     Active(A), Inactive(I), aNy(N):",NULL},
  {BSA_API_LIFECYCLE,
   "                    Associated Lifecycle Group name:",NULL},
  {BSA_API_COPYGROUP,
   "              Copy Group within the lifecycle group:",NULL},
  {BSA_API_DESCRIPTION,
   "                Descriptive label ('*' is wildcard):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*----------------------------------------------------------------------*/
/* Q u e r y   M e n u                                                  */
/*======================================================================*/
/* Definition for the sample API query menu.                            */
/*----------------------------------------------------------------------*/

menu_entry query_entries[]=
  {
  {1,"Backup Query"       ,smpxapi_qry_backup ,NULL,FALSE,
                           query_backup_dialog},
  {2,"Archive Query"      ,smpxapi_qry_archive,NULL,FALSE,
                           query_archive_dialog},
  {3,"Session Info Query" ,smpxapi_qry_sess   ,NULL,FALSE,NULL},
  {4,"API Version Query"  ,smpxapi_qry_version,NULL,FALSE,NULL},
  {9,"Quit"               ,smpxapi_query_exit ,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu query_menu[] =
  {
  query_entries,              /* Menu entries contained in main_entries  */
  "\nChoose one of the following items to query:\n"
  };

/*-----------------------------------------------------------------------.
| C h g p w _ D i a l o g
|========================================================================
| Dialog definition for changing passwords.
|________________________________________________________________________*/
dialog chgpw_dialog[]=
  {
  {BSA_API_CURRENTPW  ,"  Enter your current password:",NULL},
  {BSA_API_NEWPW1     ,"      Enter your new password:",NULL},
  {BSA_API_NEWPW2     ,"Enter your new password again:",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| D e l e t e B a c k u p _ D i a l o g
|========================================================================
| Dialog definition for deleting backup objects.
|________________________________________________________________________*/
dialog delete_backup_dialog[]=
  {
  {BSA_API_OBJSPACE    ,"                       Object Space Name:",NULL},
  {BSA_API_PATH        ,"                               Path Name:",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| D e l e t e A r c h i v e _ D i a l o g
|========================================================================
| Dialog definition for deleting archive objects.
|________________________________________________________________________*/
dialog delete_archive_dialog[]=
  {
  {BSA_API_OBJSPACE,
   "                                  Object Space Name:",NULL},
  {BSA_API_PATH,
   "                                          Path Name:",NULL},
  {BSA_API_OBJTYPE,
   "           Object Type(Any/File/Directory/dataBase):",NULL},
  {BSA_API_RESTYPE,
   "                                      Resource Type:",NULL},
  {BSA_API_LOWCREATE,
   "    Lower bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPCREATE,
   "    Upper bound on create time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_LOWEXPI,
   "Lower bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_UPEXPI,
   "Upper bound on expiration time(yyyy/mm/dd hh:mm:ss):",NULL},
  {BSA_API_BSAOBJOWN,
   "                              BSA Object Owner Name:",NULL},
  {BSA_API_APPOBJOWN,
   "                      Application Object Owner Name:",NULL},
  {BSA_API_STATUS,
   "                     Active(A), Inactive(I), aNy(N):",NULL},
  {BSA_API_LIFECYCLE,
   "                    Associated Lifecycle Group name:",NULL},
  {BSA_API_COPYGROUP,
   "              Copy Group within the lifecycle group:",NULL},
  {BSA_API_DESCRIPTION,
   "                Descriptive label ('*' is wildcard):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*----------------------------------------------------------------------*/
/* D e l e t e   M e n u                                                */
/*======================================================================*/
/* Definition for the sample API delete menu.                           */
/*----------------------------------------------------------------------*/

menu_entry delete_entries[]=
  {
  {1,"Mark Backup Object Inactive" ,smpxapi_mar_backup ,NULL,FALSE,
                                           delete_backup_dialog},
  {2,"Delete Archive Object"       ,smpxapi_del_archive,NULL,FALSE,
                                           delete_archive_dialog},
  {9,"Quit"            ,smpxapi_del_exit,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu delete_menu[] =
  {
  delete_entries,             /* Menu entries for this menu item.        */
 "\nChoose one of the following areas to delete objects from:\n"
  };

/*-----------------------------------------------------------------------.
| S e n d B u f f e r S i z e _ D i a l o g
|========================================================================
| Dialog definition for querying the size of the send buffer.
|________________________________________________________________________*/
dialog pref_send_buffer_dialog[]=
  {
  {BSA_API_SENDBUFFSIZE,
   "New value for send buffer size (minimum 1 byte) or Enter to cancel:",
   NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| R e c e i v e B u f f e r S i z e _ D i a l o g
|========================================================================
| Dialog definition for querying the size of the receive buffer.
|________________________________________________________________________*/
dialog pref_receive_buffer_dialog[]=
  {
  {BSA_API_RECVBUFFSIZE,
   "New value for receive buffer size (minimum 1 byte) or Enter to cancel:",
   NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| V e r b o s e F l a g _ D i a l o g
|========================================================================
| Dialog definition for querying the value of the verbose flag.
|________________________________________________________________________*/
dialog pref_verbose_dialog[]=
  {
  {BSA_API_VERBOSEFLAG,"Set verbose flag (v=verbose, q=quiet):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*-----------------------------------------------------------------------.
| D e t a i l s F l a g _ D i a l o g
|========================================================================
| Dialog definition for querying the value of the details flag.
|________________________________________________________________________*/
dialog pref_details_dialog[]=
  {
  {BSA_API_DETAILSFLAG,"Details on query (y/n):",NULL},
  {BSA_API_END,NULL,NULL}
  };

/*----------------------------------------------------------------------*/
/* P r e f   M e n u                                                    */
/*======================================================================*/
/* Definition for the system preferences menu.                          */
/*----------------------------------------------------------------------*/

menu_entry pref_entries[]=
  {
  {1,"Query Preferences"       ,smpxapi_pref_query   ,NULL,FALSE,NULL},
  {2,"Set send buffer size:"   ,smpxapi_pref_sendbuff,NULL,FALSE,
                                pref_send_buffer_dialog},
  {3,"Set receive buffer size:",smpxapi_pref_recvbuff,NULL,FALSE,
                                pref_receive_buffer_dialog},
  {4,"Use verbose output?"     ,smpxapi_pref_verbose ,NULL,FALSE,
                                pref_verbose_dialog},
  {5,"Show details on queries?",smpxapi_pref_details ,NULL,FALSE,
                                pref_details_dialog},
  {9,"Quit"                    ,smpxapi_pref_exit,NULL,TRUE ,NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu pref_menu[] =
  {
  pref_entries,               /* Menu entries for this menu item.        */
  "\nChoose one of the following preference items to change:\n"
  };

/*----------------------------------------------------------------------*/
/* M a i n   M e n u                                                    */
/*======================================================================*/
/* Definition for the sample XOpen API main menu.  The sample XOpen API */
/* is a simple table driven application that exercises the various      */
/* functions of the XOpen Data Movement API.                            */
/* This table defines the main functions that the sample                */
/* application will perform under user control.                         */
/*----------------------------------------------------------------------*/
/* Structure of each menu entry is:                                     */
/* Selection number (0 - n)                                             */
/* Selection description (Backup...                                     */
/* Function to call if selection chosen                                 */
/* Pointer to next menu if nested.                                      */
/* Boolean indicating if to exit from menu                              */
/* Dialog to use.                                                       */

menu_entry main_entries[]=
  {
  {0,"Signon"          ,smpxapi_signon  ,NULL      ,FALSE,
                                                    signon_dialog},
  {1,"Backup"          ,smpxapi_backup  ,NULL      ,FALSE, 
                                                    backup_dialog},
  {2,"Restore"         ,smpxapi_restore ,NULL      ,FALSE,
                                                    restore_dialog},
  {3,"Archive"         ,smpxapi_archive ,NULL      ,FALSE,
                                                    archive_dialog},
  {4,"Retrieve"        ,smpxapi_retrieve,NULL      ,FALSE,
                                                    retrieve_dialog},
  {5,"Queries"         ,NULL            ,query_menu,FALSE,
                                                    NULL},  
  {6,"Change Password" ,smpxapi_chgpw   ,NULL      ,FALSE,
                                                    chgpw_dialog},
  {7,"Delete object(s)",NULL           ,delete_menu,FALSE,
                                                    NULL},
  {8,"Preferences"     ,NULL           ,pref_menu  ,FALSE,
                                                    NULL},
  {9,"Exit to system"  ,smpxapi_exit    ,NULL      ,TRUE, 
                                                    NULL},
  {MENU_END,NULL,NULL,NULL,TRUE,NULL}
  };

menu main_menu[]=
  {
  main_entries,               /* Menu entries contained in main_entries  */
  "\nChoose one of the following actions to test:\n"
  };

#endif

