/************************************************************************
* Name:
*        xapilist.h 
* Header file for the sorted object descriptor list type.
* The list is sorted in ascending order by the restoreOrder field.
************************************************************************/

#include "custom.h"         /* Definitions for platform specific types */
#include "policy.h"         /* XOpen API type definitions              */

#ifndef _TList_H
#define _TList_H

#ifndef TypeList
   typedef void *TList;
#endif

#ifdef _NO_PROTO_
TList             Create_List();
void              Dispose_List();
ObjectDescriptor* Current_List();
void              Insert_List();
void              Append_List();
void              Delete_List();
BSA_Boolean       StopAt_List();
void              GoStart_List();
void              GoEnd_List();
void              StepNext_List();
BSA_Boolean       IsEmpty_List();
BSA_Boolean       OffStart_List();
BSA_Boolean       OffEnd_List();
BSA_Boolean       SmallerValue();
BSA_Boolean       SameValue();
#else /* use ANSI C required prototypes */
TList             Create_List();
void              Dispose_List(TList *objectDescList);
ObjectDescriptor* Current_List(TList objectDescList);
void              Insert_List(TList objectDescList, 
                         ObjectDescriptor *objectDescriptorPtr);
void              Append_List(TList objectDescList,
                         ObjectDescriptor *objectDescriptorPtr);
void              Delete_List(TList objectDescList);
BSA_Boolean       StopAt_List(TList objectDescList,
                         ObjectDescriptor *objectDescriptorPtr);
void              GoStart_List(TList objectDescList);
void              GoEnd_List(TList objectDescList);
void              StepNext_List(TList objectDescList);
BSA_Boolean       IsEmpty_List(TList objectDescList);
BSA_Boolean       OffStart_List(TList objectDescList);
BSA_Boolean       OffEnd_List(TList objectDescList);
BSA_Boolean       SmallerValue(ObjectDescriptor *objectDescPtr1,
                               ObjectDescriptor *objectDescPtr2);
BSA_Boolean       SameValue(ObjectDescriptor *objectDescPtr1,
                            ObjectDescriptor *objectDescPtr2);
#endif

#endif
