/**************************************************************************/
/* Header File Name: xapint64.h                                           */
/*                                                                        */
/* Descriptive-name: Definitions for X/Open API external BSA_Int64        */
/*                   routines                                             */
/**************************************************************************/
#ifndef _H_XAPINT64
#define _H_XAPINT64

#define EQUAL         0
#define GREATERTHAN   1
#define LESSTHAN      2

#ifdef _NO_PROTO_
extern BSA_UInt64 Make64();
extern BSA_UInt64 Incr64();
extern BSA_UInt64 Decr64();
extern BSA_UInt64 Add64();
extern BSA_UInt64 Sub64();
extern BSA_UInt16 Cmp64();
extern void       ShiftR64();
extern void       ShiftL64();
extern BSA_UInt64 Mul64();
extern BSA_UInt64 Div64();
extern char       *I64toCh();
extern BSA_UInt64 ChtoI64();
#else /* use ANSI C required prototypes */
extern BSA_UInt64 Make64( BSA_UInt32 n );
extern BSA_UInt64 Incr64( BSA_UInt64 x, BSA_UInt32 n );
extern BSA_UInt64 Decr64( BSA_UInt64 x, BSA_UInt32 n );
extern BSA_UInt64 Add64( BSA_UInt64 x, BSA_UInt64 y );
extern BSA_UInt64 Sub64( BSA_UInt64 x, BSA_UInt64 y );
extern BSA_UInt16 Cmp64( BSA_UInt64 x, BSA_UInt64 y );
extern void       ShiftR64( BSA_UInt64 *x, unsigned int b );
extern void       ShiftL64( BSA_UInt64 *x, unsigned int b );
extern BSA_UInt64 Mul64( BSA_UInt64 x, BSA_UInt64 y, int *overflow );
extern BSA_UInt64 Div64( BSA_UInt64 x, BSA_UInt64 y, BSA_UInt64 *rmdrP );
extern char  *I64toCh( BSA_UInt64 value, char *string, int radix );
extern BSA_UInt64 ChtoI64( char *str, int radix );
#endif

#endif
