/***********************************************************************
* Name:
*        xapiour.h
*
***********************************************************************/
#ifndef _H_XAPIOUR
#define _H_XAPIOUR

#include "custom.h"         /* Definitions for platform specific types */
#include "policy.h"         /* XOpen API type definitions              */

#ifdef _NO_PROTO_
extern void      ourQueryApiVersion();
extern BSA_Int16 ourInit();
extern BSA_Int16 ourResolveLifecycleGroup();
extern BSA_Int16 ourCreateObject();
extern BSA_Int16 ourSendData();
extern BSA_Int16 ourBeginTxn();
extern BSA_Int16 ourEndTxn();
extern BSA_Int16 ourEndData();
extern BSA_Int16 ourGetObject();
extern BSA_Int16 ourQueryObject();
extern BSA_Int16 ourGetNextQueryObject();
extern BSA_Int16 ourGetData();
extern BSA_Int16 ourTerminate();
extern BSA_Int16 ourChangeToken();
extern BSA_Int16 check_signon();
extern BSA_Int16 ourGetEnvironment();
extern BSA_Int16 ourDeleteObject();
extern BSA_Int16 ourMarkObjectInactive();
extern void      rcXApiOut();
#else /* use ANSI C required prototypes */
extern void      ourQueryApiVersion(ApiVersion *apiVersion);
extern BSA_Int16 ourInit(SecurityToken *tokenPtr,
                         ObjectOwner   *objectOwnerPtr);
extern BSA_Int16 ourResolveLifecycleGroup(
                                 ObjectDescriptor *objectDescriptorPtr);
extern BSA_Int16 ourCreateObject(char             *send_buffer,
                                 ObjectDescriptor *objectDescriptorPtr);
extern BSA_Int16 ourSendData(char       *send_buffer,
                             BSA_UInt32 buffer_length);
extern BSA_Int16 ourBeginTxn();
extern BSA_Int16 ourEndTxn(Vote vote);
extern BSA_Int16 ourEndData();
extern BSA_Int16 ourGetObject(ObjectDescriptor *objectDescriptorPtr,
                              DataBlock        *dataBlockPtr);
extern BSA_Int16 ourQueryObject(QueryDescriptor  *queryDescriptorPtr,
                                ObjectDescriptor *objectDescriptorPtr);
extern BSA_Int16 ourGetNextQueryObject(
                                ObjectDescriptor *objectDescriptorPtr);
extern BSA_Int16 ourGetData(DataBlock *dataBlockPtr);
extern BSA_Int16 ourTerminate();
extern BSA_Int16 ourChangeToken(SecurityToken *oldTokenPtr,
                                SecurityToken *newTokenPtr);
extern BSA_Int16 check_signon();
extern BSA_Int16 ourGetEnvironment(ObjectOwner   *objectOwnerPtr,
                                  char           **environmentPtr);
extern BSA_Int16 ourDeleteObject(CopyType   copyType,
                                 ObjectName *objNamePtr,
                                 CopyId     *copyIdPtr);
extern BSA_Int16 ourMarkObjectInactive(ObjectName *objectNamePtr);
extern void      rcXApiOut(BSA_Int16 rc);
#endif

#endif

