/***********************************************************************
* Name:
*        xapiutil.h
***********************************************************************/
#ifndef _H_XAPIUTIL
#define _H_XAPIUTIL

#include "custom.h"         /* Definitions for platform specific types */
#include "policy.h"         /* XOpen API type definitions              */

#ifdef _NO_PROTO_
extern void              format_number();
extern ObjectDescriptor* create_objDesc();
extern void              dispose_objDesc();
extern void              dispose_queryDesc();
extern QueryDescriptor*  create_queryDesc();
extern DataBlock*        create_dataBlock();
extern char*             create_buffer();
extern void              dispose_buffer();
extern void              dispose_dataBlock();
extern struct tm         get_time();
extern BSA_Int16         max16();
extern void              cpy_seed_to_buffer();
extern BSA_Int16         buid_object_info();
extern BSA_Int16         restore_object_info();
extern BSA_Int16         check_Data();
extern ObjectOwner*      create_objOwner();
extern void              dispose_objOwner();
extern void              print_object_descriptor();
#else /* use ANSI C required prototypes */
extern void              format_number(char *s_in, char *s_out);
extern ObjectDescriptor* create_objDesc();
extern void              dispose_objDesc(
                            ObjectDescriptor *objectDescriptorPtr);
extern void              dispose_queryDesc(
                            QueryDescriptor *queryDescriptorPtr);
extern QueryDescriptor*  create_queryDesc();
extern DataBlock*        create_dataBlock(BSA_UInt32 size);
extern char*             create_buffer(BSA_UInt32 size);
extern void              dispose_buffer(char *bufferPtr);
extern void              dispose_dataBlock(DataBlock *dataBlockPtr);
extern struct tm         get_time(char *timeString,
                                  BSA_Int16 default_limit);
extern BSA_Int16         max16(BSA_Int16 x, BSA_Int16 y);
extern void              cpy_seed_to_buffer(char       *bufferPtr,
                                            char       *seedString,
                                            BSA_UInt32 length);
extern BSA_Int16         build_object_info(
                                       ObjectDescriptor *objectDescriptorPtr,
                                       char             *SeedString);
extern BSA_Int16         restore_object_info(
                                       ObjectDescriptor *objectDescriptorPtr,
                                       char             **SeedStringPtr);
extern BSA_Int16         check_Data(DataBlock        *dataBlockPtr,
                                    char             *seedString,
                                    BSA_UInt16       *offsetPtr);
extern ObjectOwner*      create_objOwner();
extern void              dispose_objOwner(ObjectOwner *objectOwnerPtr);
extern void              print_object_descriptor
                                    (ObjectDescriptor *objectDescriptorPtr);
#endif

#endif

